//+------------------------------------------------------------------+
//|                                                         max3.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers  1
#property indicator_color1   DeepSkyBlue
#property indicator_width1   2

//
//
//
//
//

extern int    maPeriod = 14;
extern int    maPrice  = PRICE_CLOSE;
extern double maPower  = 3;

//
//
//
//
//

double maxBuffer[];
double wrkBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,maxBuffer);
   SetIndexBuffer(1,wrkBuffer);
         maPeriod = MathMax(maPeriod,1);
         maPower  = MathMax(maPower,0.01);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--)
   {
      wrkBuffer[i] = iMA(NULL,0,1,0,MODE_SMA,maPrice,i);
      if (i==(Bars-1))
         {
            maxBuffer[i] = wrkBuffer[i]; continue;
         }
         
      //
      //
      //
      //
      //
               
      double sumw = 0;
      double sump = 0;
      double count = MathMin(Bars-i,maPeriod);
      
         for (int k=0; k<count; k++)
         {
            double pow = MathPow(count-k,maPower);
                  sumw += pow;
                  sump += pow*wrkBuffer[i+k];
         }
         
      if (sumw!=0)
            maxBuffer[i] = sump/sumw;
      else  maxBuffer[i] = EMPTY_VALUE;       
   }
   return(0);
}

